STIF_DEFAULT = 0
STIF_SUPPORT_HEX = 1

GCT_INVALID = 0
GCT_LFNCHAR = 1
GCT_SHORTCHAR = 2
GCT_WILD = 4
GCT_SEPARATOR = 8

URL_SCHEME_INVALID = -1
URL_SCHEME_UNKNOWN = 0
URL_SCHEME_FTP = 1
URL_SCHEME_HTTP = 2
URL_SCHEME_GOPHER = 3
URL_SCHEME_MAILTO = 4
URL_SCHEME_NEWS = 5
URL_SCHEME_NNTP = 6
URL_SCHEME_TELNET = 7
URL_SCHEME_WAIS = 8
URL_SCHEME_FILE = 9
URL_SCHEME_MK = 10
URL_SCHEME_HTTPS = 11
URL_SCHEME_SHELL = 12
URL_SCHEME_SNEWS = 13
URL_SCHEME_LOCAL = 14
URL_SCHEME_JAVASCRIPT = 15
URL_SCHEME_VBSCRIPT = 16
URL_SCHEME_ABOUT = 17
URL_SCHEME_RES = 18
URL_SCHEME_MSSHELLROOTED = 19
URL_SCHEME_MSSHELLIDLIST = 20
URL_SCHEME_MSHELP = 21
URL_SCHEME_MAXVALUE = 22

URL_PART_NONE = 0
URL_PART_SCHEME = 1
URL_PART_HOSTNAME = 2
URL_PART_USERNAME = 3
URL_PART_PASSWORD = 4
URL_PART_PORT = 5
URL_PART_QUERY = 6

URLIS_URL = 0
URLIS_OPAQUE = 1
URLIS_NOHISTORY = 2
URLIS_FILEURL = 3
URLIS_APPLIABLE = 4
URLIS_DIRECTORY = 5
URLIS_HASQUERY = 6

URL_UNESCAPE = $10000000
URL_ESCAPE_UNSAFE = $20000000
URL_PLUGGABLE_PROTOCOL = $40000000
URL_WININET_COMPATIBILITY = $80000000
URL_DONT_ESCAPE_EXTRA_INFO = $2000000
URL_DONT_UNESCAPE_EXTRA_INFO = URL_DONT_ESCAPE_EXTRA_INFO
URL_BROWSER_MODE = URL_DONT_ESCAPE_EXTRA_INFO
URL_ESCAPE_SPACES_ONLY = $4000000
URL_DONT_SIMPLIFY = $8000000
URL_NO_META = URL_DONT_SIMPLIFY
URL_UNESCAPE_INPLACE = $100000
URL_CONVERT_IF_DOSPATH = $200000
URL_UNESCAPE_HIGH_ANSI_ONLY  = $400000
URL_INTERNAL_PATH = $800000
URL_FILE_USE_PATHURL = $10000
URL_DONT_UNESCAPE = $20000
URL_ESCAPE_PERCENT = $1000
URL_ESCAPE_SEGMENT_ONLY = $2000

URL_PARTFLAG_KEEPSCHEME = 1

URL_APPLY_DEFAULT = 1
URL_APPLY_GUESSSCHEME = 2
URL_APPLY_GUESSFILE = 4
URL_APPLY_FORCEAPPLY = 8

SRRF_RT_REG_NONE = 1
SRRF_RT_REG_SZ = 2
SRRF_RT_REG_EXPAND_SZ = 4
SRRF_RT_REG_BINARY = 8
SRRF_RT_REG_DWORD = $10
SRRF_RT_REG_MULTI_SZ = $20
SRRF_RT_REG_QWORD = $40

SRRF_RT_DWORD = (SRRF_RT_REG_BINARY or SRRF_RT_REG_DWORD)
SRRF_RT_QWORD = (SRRF_RT_REG_BINARY or SRRF_RT_REG_QWORD)
SRRF_RT_ANY = $ffff

SRRF_RM_ANY = 0
SRRF_RM_NORMAL = $10000
SRRF_RM_SAFE = $20000
SRRF_RM_SAFENETWORK = $40000

SRRF_NOEXPAND = $10000000
SRRF_ZEROONFAILURE = $20000000

SHREGDEL_DEFAULT = 0
SHREGDEL_HKCU = 1
SHREGDEL_HKLM = $10
SHREGDEL_BOTH = $11

SHREGENUM_DEFAULT = 0
SHREGENUM_HKCU = 1
SHREGENUM_HKLM = $10
SHREGENUM_BOTH = $11

SHREGSET_HKCU = 1
SHREGSET_FORCE_HKCU = 2
SHREGSET_HKLM = 4
SHREGSET_FORCE_HKLM = 8
SHREGSET_DEFAULT = (SHREGSET_FORCE_HKCU or SHREGSET_HKLM)

ASSOCF_INIT_NOREMAPCLSID = 1
ASSOCF_INIT_BYEXENAME = 2
ASSOCF_OPEN_BYEXENAME = 2
ASSOCF_INIT_DEFAULTTOSTAR = 4
ASSOCF_INIT_DEFAULTTOFOLDER = 8
ASSOCF_NOUSERSETTINGS = 10
ASSOCF_NOTRUNCATE = 20
ASSOCF_VERIFY = 40
ASSOCF_REMAPRUNDLL = 80
ASSOCF_NOFIXUPS = 100
ASSOCF_IGNOREBASECLASS = 200

ASSOCSTR_COMMAND = 1
ASSOCSTR_EXECUTABLE = 2
ASSOCSTR_FRIENDLYDOCNAME = 3
ASSOCSTR_FRIENDLYAPPNAME = 4
ASSOCSTR_NOOPEN = 5
ASSOCSTR_SHELLNEWVALUE = 6
ASSOCSTR_DDECOMMAND = 7
ASSOCSTR_DDEIFEXEC = 8
ASSOCSTR_DDEAPPLICATION = 9
ASSOCSTR_DDETOPIC = 10
ASSOCSTR_INFOTIP = 11
ASSOCSTR_QUICKTIP = 12
ASSOCSTR_TILEINFO = 13
ASSOCSTR_CONTENTTYPE = 14
ASSOCSTR_DEFAULTICON = 15
ASSOCSTR_SHELLEXTENSION = 16
ASSOCSTR_MAX = 17

ASSOCKEY_SHELLEXECCLASS = 1
ASSOCKEY_APP = 2
ASSOCKEY_CLASS = 3
ASSOCKEY_BASECLASS = 4
ASSOCKEY_MAX = 5

ASSOCDATA_MSIDESCRIPTOR = 1
ASSOCDATA_NOACTIVATEHANDLER = 2
ASSOCDATA_QUERYCLASSSTORE = 3
ASSOCDATA_HASPERUSERASSOC = 4
ASSOCDATA_EDITFLAGS = 5
ASSOCDATA_VALUE = 6
ASSOCDATA_MAX = 7

ASSOCENUM_NONE = 0

interface IQueryAssociations,\
	  QueryInterface,\
	  AddRef,\
	  Release,\
	  Init,\
	  GetString,\
	  GetKey,\
	  GetData,\
	  GetEnum

PERCEIVED_TYPE_CUSTOM = -3
PERCEIVED_TYPE_UNSPECIFIED = -2
PERCEIVED_TYPE_FOLDER = -1
PERCEIVED_TYPE_UNKNOWN = 0
PERCEIVED_TYPE_TEXT = 2
PERCEIVED_TYPE_IMAGE = 3
PERCEIVED_TYPE_AUDIO = 4
PERCEIVED_TYPE_VIDEO = 5
PERCEIVED_TYPE_COMPRESSED = 6
PERCEIVED_TYPE_DOCUMENT = 7
PERCEIVED_TYPE_SYSTEM = 8
PERCEIVED_TYPE_APPLICATION = 9

PERCEIVEDFLAG_UNDEFINED = 0
PERCEIVEDFLAG_SOFTCODED = 1
PERCEIVEDFLAG_HARDCODED = 2
PERCEIVEDFLAG_NATIVESUPPORT = 4
PERCEIVEDFLAG_GDIPLUS = $10
PERCEIVEDFLAG_WMSDK = $20
PERCEIVEDFLAG_ZIPFOLDER = $40

SHGVSPB_PERUSER = 1
SHGVSPB_ALLUSERS = 2
SHGVSPB_PERFOLDER = 4
SHGVSPB_ALLFOLDERS = 8
SHGVSPB_INHERIT = $10
SHGVSPB_ROAM = $20
SHGVSPB_NOAUTODEFAULTS = $80000000

SHGVSPB_FOLDER = (SHGVSPB_PERUSER or SHGVSPB_PERFOLDER)
SHGVSPB_FOLDERNODEFAULTS = (SHGVSPB_PERUSER or SHGVSPB_PERFOLDER or SHGVSPB_NOAUTODEFAULTS)
SHGVSPB_USERDEFAULTS = (SHGVSPB_PERUSER or SHGVSPB_ALLFOLDERS)
SHGVSPB_GLOBALDEAFAULTS = (SHGVSPB_ALLUSERS or SHGVSPB_ALLFOLDERS)

SHACF_DEFAULT = 0
SHACF_FILESYSTEM = 1
SHACF_URLALL = (SHACF_URLHISTORY or SHACF_URLMRU)
SHACF_URLHISTORY = 2
SHACF_URLMRU = 4
SHACF_USETAB = 8
SHACF_FILESYS_ONLY = $10
SHACF_FILESYS_DIRS = $20

SHACF_AUTOSUGGEST_FORCE_ON = $10000000
SHACF_AUTOSUGGEST_FORCE_OFF = $20000000
SHACF_AUTOAPPEND_FORCE_ON = $40000000
SHACF_AUTOAPPEND_FORCE_OFF = $80000000

CTF_INSIST = 1
CTF_THREAD_REF = 2
CTF_PROCESS_REF = 4
CTF_COINIT = 8
CTF_FREELIBANDEXIT = $10
CTF_REF_COUNTED = $20
CTF_WAIT_ALLOWCOM = $40

struct DLLVERSIONINFO
       cbSize dd ?
       dwMajorVersion dd ?
       dwMinorVersion dd ?
       dwBuildNumber dd ?
       dwPlatformID dd ?
ends

DLLVER_PLATFORM_WINDOWS = 1
DLLVER_PLATFORM_NT = 2

struct DLLVERSIONINFO2
       info1 DLLVERSIONINFO
       dwFlags dd ?
       ullVersion dq ?
ends

DLLVER_MAJOR_MASK = $FFFF000000000000
DLLVER_MINOR_MASK = $FFFF00000000
DLLVER_BUILD_MASK = $FFFF0000
DLLVER_QFE_MASK = $FFFF

macro MAKEDLLVERULL major, minor, build, qfe {
      VALUE = (major shl 48) + (minor shl 32) + (build shl 16) + qfe
}
